import { useCallback, useSyncExternalStore } from 'react';
import { StoreEvents } from '@tomic/lib';
import { useStore } from './index.js';
/**
 * A hook for using and adjusting the Agent in the store.
 */
export var useCurrentAgent = function () {
    var store = useStore();
    var subscribe = useCallback(function (callback) { return store.on(StoreEvents.AgentChanged, callback); }, [store]);
    var agent = useSyncExternalStore(subscribe, store.getAgent);
    return [agent, store.setAgent];
};
//# sourceMappingURL=useCurrentAgent.js.map