var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import { Datatype, properties, urls, valToArray, valToDate, } from '@tomic/lib';
import { useEffect, useState } from 'react';
import { useStore, useString, useTitle } from './index.js';
/** Properties not relevant to show in PropValLines */
var hiddenProps = [
    // Shown as title
    properties.name,
    properties.shortname,
    properties.file.filename,
    // Shown separately
    properties.description,
    // Shown in rights / share menu
    properties.write,
    properties.read,
];
/**
 * Returns a Markdown string representing the entire Resource, e.g.:
 *
 * ```md
 * # Some Title
 *
 * author: [joe](https://example.com/joe)
 *
 * published-at: 2020-01-01
 *
 * And here a description! Hello world!
 * ```
 */
export function useMarkdown(resource) {
    var _a = __read(useTitle(resource), 1), title = _a[0];
    var _b = __read(useString(resource, urls.properties.description), 1), description = _b[0];
    var _c = __read(useState("# ".concat(title)), 2), md = _c[0], setMd = _c[1];
    var store = useStore();
    useEffect(function () {
        function getPropValTexts() {
            return __awaiter(this, void 0, void 0, function () {
                var propValLines, _a, _b, _c, _d, prop, val, _e, e_1_1;
                var _f, e_1, _g, _h;
                return __generator(this, function (_j) {
                    switch (_j.label) {
                        case 0:
                            propValLines = '';
                            _j.label = 1;
                        case 1:
                            _j.trys.push([1, 7, 8, 13]);
                            _a = true, _b = __asyncValues(resource.getPropVals());
                            _j.label = 2;
                        case 2: return [4 /*yield*/, _b.next()];
                        case 3:
                            if (!(_c = _j.sent(), _f = _c.done, !_f)) return [3 /*break*/, 6];
                            _h = _c.value;
                            _a = false;
                            _d = __read(_h, 2), prop = _d[0], val = _d[1];
                            if (!!hiddenProps.includes(prop)) return [3 /*break*/, 5];
                            _e = propValLines;
                            return [4 /*yield*/, propertyLine(prop, val, store)];
                        case 4:
                            propValLines = _e + (_j.sent());
                            _j.label = 5;
                        case 5:
                            _a = true;
                            return [3 /*break*/, 2];
                        case 6: return [3 /*break*/, 13];
                        case 7:
                            e_1_1 = _j.sent();
                            e_1 = { error: e_1_1 };
                            return [3 /*break*/, 13];
                        case 8:
                            _j.trys.push([8, , 11, 12]);
                            if (!(!_a && !_f && (_g = _b.return))) return [3 /*break*/, 10];
                            return [4 /*yield*/, _g.call(_b)];
                        case 9:
                            _j.sent();
                            _j.label = 10;
                        case 10: return [3 /*break*/, 12];
                        case 11:
                            if (e_1) throw e_1.error;
                            return [7 /*endfinally*/];
                        case 12: return [7 /*endfinally*/];
                        case 13:
                            setMd("# ".concat(title) + propValLines + '\n\n' + description);
                            return [2 /*return*/];
                    }
                });
            });
        }
        getPropValTexts();
    }, [resource]);
    if (resource.error) {
        return resource.error.message;
    }
    return md;
}
/** Renders a single Atomic Property + Value as a single Markdown line */
function propertyLine(propertySubject, value, store) {
    return __awaiter(this, void 0, void 0, function () {
        var property, valString;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, store.getProperty(propertySubject)];
                case 1:
                    property = _a.sent();
                    valString = value === null || value === void 0 ? void 0 : value.toString();
                    switch (property.datatype) {
                        case Datatype.ATOMIC_URL:
                            valString = "[".concat(value, "](").concat(value, ")");
                            break;
                        case Datatype.RESOURCEARRAY:
                            {
                                valString = '';
                                valToArray(value).map(function (item) {
                                    valString = valString + "[".concat(item, "](").concat(item, "),");
                                });
                            }
                            break;
                        case Datatype.TIMESTAMP:
                            valString = valToDate(value).toLocaleString();
                            break;
                    }
                    return [2 /*return*/, "\n\n**".concat(property.shortname, "**: ").concat(valString)];
            }
        });
    });
}
//# sourceMappingURL=useMarkdown.js.map