import { SearchOpts } from '@tomic/lib';
interface SearchResults {
    /** Subject URLs for resources that match the query */
    results: string[];
    loading: boolean;
    error?: Error;
}
interface SearchOptsHook extends SearchOpts {
    /**
     * Debouncing makes queries slower, but prevents sending many request. Number
     * respresents milliseconds.
     */
    debounce?: number;
    allowEmptyQuery?: boolean;
}
/** Escape values for use in filter string */
export declare const escapeFilterValue: (value: string) => string;
/** Pass a query to search the current server */
export declare function useServerSearch(query: string | undefined, opts?: SearchOptsHook): SearchResults;
export {};
//# sourceMappingURL=useServerSearch.d.ts.map